﻿Imports FarPoint.Win.Spread
Imports FarPoint.Win.Spread.Model
Public Class Form1
    Private m_Table As New DataTable()
    Sub CreateColumns(ByVal editable As Boolean)
        Me.m_Table.Columns.Add(New DataColumn() With {.ColumnName = "ID", .DataType = GetType(Long), .AutoIncrement = True, .AutoIncrementSeed = 1})
        Me.m_Table.Columns.Add(New DataColumn() With {.ColumnName = "EDITTYPE", .DataType = GetType(Char), .ReadOnly = Not editable})
        Me.m_Table.Columns.Add(New DataColumn() With {.ColumnName = "EDITA", .DataType = GetType(Date), .ReadOnly = Not editable})
        Me.m_Table.Columns.Add(New DataColumn() With {.ColumnName = "EDITBY", .DataType = GetType(String), .ReadOnly = Not editable})
        Me.m_Table.Columns.Add(New DataColumn() With {.ColumnName = "EDITLOCATION", .DataType = GetType(String), .ReadOnly = Not editable})
        Me.m_Table.Columns.Add(New DataColumn() With {.ColumnName = "ColumnA", .DataType = GetType(Decimal), .ReadOnly = Not editable})
    End Sub
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.CreateColumns(editable:=False)
        Me.spr_Main_Sheet1.DataSource = (New Testdata(Me.m_Table, rowCount:=30).Table)
        Dim gdm As New GroupDataModel(Me.spr_Main_Sheet1.Models.Data)
        Dim sortInfos As New List(Of SortInfo)()
        sortInfos.Add(New SortInfo(3, ascending:=True))
        gdm.Group(sortInfos.ToArray())
        gdm.GroupFooterVisible = True
        Me.spr_Main_Sheet1.Models.Data = gdm
    End Sub
    Private Sub Form1_Shown(sender As Object, e As EventArgs) Handles Me.Shown
        Dim gdm = DirectCast(Me.spr_Main_Sheet1.Models.Data, GroupDataModel)
        ' The format dd.mm.yyyy using dots (which denote ordinal numbering) is the traditional German date format, see here https://en.wikipedia.org/wiki/Date_format_by_country
        Me.spr_Main_Sheet1.Columns(2).CellType = New CellType.DateTimeCellType() With {.DateTimeFormat = CellType.DateTimeFormat.UserDefined, .UserDefinedFormat = "dd.MM.yyyy HH:mm:ss"}

        For i = 0 To gdm.Groups.Count - 1
            Dim group = DirectCast(gdm.Groups(i), Group)
            DirectCast(group.GroupFooter.DataModel, IAggregationSupport).SetCellAggregationType(row:=0, col:=2, type:=AggregationType.Max) ' column EDITA
            DirectCast(group.GroupFooter.DataModel, IAggregationSupport).SetCellAggregationFormat(row:=0, col:=2, format:="{0:dd.MM.yyyy}")
            DirectCast(group.GroupFooter.DataModel, IAggregationSupport).SetCellAggregationType(row:=0, col:=5, type:=AggregationType.Max) ' column ColumnA
            ' in German region is a decimal separator a , see here https://en.wikipedia.org/wiki/Decimal_separator and the , is also displayed. Example: "24389,00" This is ok.
            DirectCast(group.GroupFooter.DataModel, IAggregationSupport).SetCellAggregationFormat(row:=0, col:=5, format:="{0:0.00}")
        Next
    End Sub
    Private Sub spr_Main_Grouped(sender As Object, e As EventArgs) Handles spr_Main.Grouped
        Me.lst_Events.Items.Add(String.Format("#{0}: spr_Main_Grouped", Me.lst_Events.Items.Count + 1))
    End Sub
    Private Sub spr_Main_Grouping(sender As Object, e As GroupingEventArgs) Handles spr_Main.Grouping
        Me.lst_Events.Items.Add(String.Format("#{0}: spr_Main_Grouping", Me.lst_Events.Items.Count + 1))
    End Sub
End Class
